<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="130px">
      <el-form-item label="重泡货类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择重泡货类型" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.ZHONG_PAO_TYPE)"
                     :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
<!--      <el-form-item label="始发地ID" prop="departureId">-->
<!--        <el-input v-model="queryParams.departureId" placeholder="请输入始发地ID" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
<!--      <el-form-item label="目的地ID列表" prop="objectiveIds">-->
<!--        <el-input v-model="queryParams.objectiveIds" placeholder="请输入目的地ID列表" clearable @keyup.enter.native="handleQuery"/>-->
<!--      </el-form-item>-->
      <el-form-item label="创建时间">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:zhong-pao:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:zhong-pao:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="序号" type="index" width="50px" />
      <el-table-column label="重泡货类型" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ZHONG_PAO_TYPE" :value="scope.row.type" />
        </template>
      </el-table-column>
      <el-table-column label="运输方式" align="center" prop="transportTypes">
        <template slot-scope="scope">
          <span v-for="item in scope.row.transportTypes.split(',')"><dict-tag :type="DICT_TYPE.TRANSPORT_TYPE" :value="item" />, </span>
        </template>
      </el-table-column>
      <el-table-column label="始发地" align="center" prop="departureId" :formatter="departureFormatter"/>
      <el-table-column label="目的地" align="center" prop="objectiveIds" :formatter="objectiveFormatter"/>
      <el-table-column label="临介值标准" align="center" prop="edge" />
      <el-table-column label="计算公式" align="center" prop="formulas" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="transportTypes">
        <template v-slot="scope">
          <el-switch v-model="scope.row.status" @change="handleStatusChange(scope.row)" :active-value="0" :inactive-value="1"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:zhong-pao:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-show="scope.row.departureId !== 0 || scope.row.objectiveIds !== '0'"
                     v-hasPermi="['ecw:zhong-pao:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="540px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="重泡货类型" prop="type">
          <el-select v-model="form.type" placeholder="请选择重泡货类型" @change="form.transportTypes = ''">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.ZHONG_PAO_TYPE)"
                       :key="dict.value" :label="dict.label" :value="parseInt(dict.value)" />
          </el-select>
        </el-form-item>
        <el-form-item label="运输方式" prop="transportTypes">
          <dict-selector :type="DICT_TYPE.TRANSPORT_TYPE" v-model="form.transportTypes" multiple form-type="checkbox" :filter="transportTypesFilter"></dict-selector>
        </el-form-item>
        <el-form-item label="始发地" prop="departureId">
          <el-select v-model="form.departureId" placeholder="请选择始发地">
            <el-option label="全部" :value="0"></el-option>
            <el-option v-for="(item) in expoerCityList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="目的地" prop="objectiveIds">
<!--          <el-input v-model="form.objectiveIds" placeholder="请输入目的地ID列表" />-->
          <el-select v-model="form.objectiveIds" placeholder="请选择目的地" multiple>
            <el-option label="全部" value="0"></el-option>
            <el-option v-for="(item) in importCityList" :label="item.titleZh" :value="item.id.toString()" :key="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="`${form.type !== 1 ? '泡' : '重'}货临介值`" prop="edge">
          <el-input v-model="form.edge" placeholder="请输入临介值">
            <template slot="prepend">每CBM{{form.type !== 1 ? '小' : '大'}}于</template>
            <template slot="append">kg属于{{form.type !== 1 ? '泡' : '重'}}货</template>
          </el-input>
        </el-form-item>
        <el-form-item label="公式" prop="formulas">
          <el-input v-model="form.formulas" placeholder="请输入公式">
            <template slot="prepend">{{form.type !== 1 ? '泡货重量(kg)=实际体积（CBM）*' : '重货体积(CBM)=实际重量（KG）*'}} </template>
          </el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createZhongPao, updateZhongPao, deleteZhongPao, getZhongPao, getZhongPaoPage, exportZhongPaoExcel } from "@/api/ecw/zhongPao";
import {DICT_TYPE, getDictDatas} from "@/utils/dict"
import {parseTime} from "@/utils/ruoyi"
import DictSelector from "@/components/DictSelector"
import {getTradeCityList} from "@/api/ecw/region"
import {getWarehouseList} from "@/api/ecw/warehouse"
import { CommonStatusEnum } from '@/utils/constants'

export default {
  name: "ZhongPao",
  components: {
    DictSelector
  },
  data() {
    return {
      DICT_TYPE,
      getDictDatas,
      parseTime,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 重泡货配置列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        type: null,
        departureId: null,
        objectiveIds: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      importCityList: [],
      warehouseList: [],
      tradeCityList:[]
    };
  },
  created() {
    this.getList();
    getTradeCityList({type: 1}).then(r => {
      this.importCityList = r.data.filter(item => item.type === '1')
    })
    getWarehouseList().then(r => {
      this.warehouseList = r.data
    })
    getTradeCityList().then(res => this.tradeCityList = res.data)
  },
  computed:{
    expoerCityList() {
      return this.tradeCityList.filter(item => item.type == 2)
    },
  },
  methods: {
    handleStatusChange(row){
      let text = row.status === CommonStatusEnum.ENABLE ? "启用" : "停用";
      this.$modal.confirm('确认要' + text + '吗?').then(function() {
        return updateZhongPao({
          id: row.id,
          status: row.status
        })
      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE
          : CommonStatusEnum.ENABLE;
      });
    },
    departureFormatter(row, column, cellValue) {
      if (cellValue === 0) return '全部'
      return this.warehouseList.find(e => e.id === cellValue)?.titleZh
    },
    objectiveFormatter(row, column, cellValue) {
      if (!cellValue || cellValue.length === 0) return ''
      if (cellValue === '0') return '全部'
      return cellValue.split(',').map(id => this.importCityList.find(e => e.id === parseInt(id))?.titleZh).join(', ')
    },
    transportTypesFilter({value}) {
      return (this.form.type === 1 && (value === '1' || value === '2')) || (this.form.type === 2 && (value === '3' || value === '4'))
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getZhongPaoPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        type: undefined,
        edge: undefined,
        formulas: undefined,
        transportTypes: '',
        departureId: undefined,
        objectiveIds: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加重泡货配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getZhongPao(id).then(response => {
        const form = response.data;

        form.objectiveIds = form.objectiveIds && form.objectiveIds.length > 0 ? form.objectiveIds.split(',') : []

        this.form = form
        this.open = true;
        this.title = "修改重泡货配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        let form = this.form
        form.objectiveIds = form.objectiveIds?.join(',')
        // 修改的提交
        if (this.form.id != null) {
          updateZhongPao(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
            this.reset()
          });
          return;
        }
        // 添加的提交
        createZhongPao(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
          this.reset()
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除重泡货配置编号为"' + id + '"的数据项?').then(function() {
        return deleteZhongPao(id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有重泡货配置数据项?').then(() => {
        this.exportLoading = true;
        return exportZhongPaoExcel(params);
      }).then(response => {
        this.$download.excel(response, '${table.classComment}.xls');
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
